import 'package:build/build.dart';
import 'package:dart_style/dart_style.dart';
import 'package:source_gen/source_gen.dart';
import 'dart:core';

import 'package:neat/neat_generator/generators/global_generator.dart';
import 'generators/padding_helpers_generator.dart';
import 'generators/space_widgets_generator.dart';

const String header = """
// Generated by Neat
//
// This file has been generated
// Do not modify by hand
""";

const String import = """
import 'package:flutter/material.dart';
""";

Builder neatGenerator(BuilderOptions options) {
  final formater = DartFormatter();

  return PartBuilder(
    [
      GlobalGenerator(),
      SpaceWidgetsGenerator(),
      PaddingHelpersGenerator(),
    ],
    ".nt.dart",
    formatOutput: formater.format,
    header: header,
  );
}
